/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: RefCountArray.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TEMPLATES_REF_COUNT_ARRAY_HPP_
#define _TEMPLATES_REF_COUNT_ARRAY_HPP_

#include "tops/utilities/Pointer/MessageCounter.hpp"

namespace Utility {

	/**
	 * 参照カウント型のスマートポインタ（配列用）です。
	 *
	 * @author トゥイー
	 */
	template<class T>
	class RefCountArray {
	private:
		T* m_ptr;
		MessageCounter* m_count;

	public:
		/**
		 * スマートポインタを構築します。
		 */
		explicit RefCountArray(T *p = 0) : m_ptr(p), m_count(new MessageCounter(1)) {
		}

		/**
		 * 配列のサイズを指定してスマートポインタを構築します。
		 */
		explicit RefCountArray(unsigned int size) : m_ptr(0), m_count(new MessageCounter(1)) {
			if (size) {
				m_ptr = new T[size];
			}
		}

		/**
		 * 継承を考慮したコピーコンストラクタです。
		 */
		template<class R>
		RefCountArray(const RefCountArray<R>& rhs) : m_ptr(rhs.get()), m_count(rhs.getCounter()) {
			++(*m_count);
		}

		/**
		 * コピーコンストラクタです。
		 */
		RefCountArray(const RefCountArray<T>& rhs) : m_ptr(rhs.m_ptr), m_count(rhs.m_count) {
			++(*m_count);
		}

		/**
		 * スマートポインタを破棄します。
		 */
		virtual ~RefCountArray() {
			refcountdec();
		}

	public:
		/**
		 * 継承を考慮した代入演算子です。
		 */
		template<class R>
		RefCountArray<T>& operator=(const RefCountArray<R>& rhs) {
			if (m_ptr != rhs.m_ptr) {
				refcountdec();
				m_ptr = rhs.m_ptr;
				m_count = rhs.m_count;
				++(*m_count);
			}

			return *this;
		}

		/**
		 * 代入演算子です。
		 */
		RefCountArray<T>& operator=(const RefCountArray<T>& rhs) {
			if (m_ptr != rhs.m_ptr) {
				refcountdec();
				m_ptr = rhs.m_ptr;
				m_count = rhs.m_count;
				++(*m_count);
			}

			return *this;
		}

	public:
		/**
		 * ポインタが値を持つかどうかを判定します。
		 *
		 * @return ポインタが値を持つ場合はtrueを、NULLの場合はfalseを返します。
		 */
		operator bool() const {
			return 0 != m_ptr;
		}

		/**
		 * ポインタがNULL値かどうかを判定します。
		 *
		 * @return ポインタがNULLの場合はtrueを、値を持つ場合はfalseを返します。
		 */
		bool operator!() const {
			return 0 == m_ptr;
		}

	public:
		/**
		 * 添字演算子（インスペクタ）です。
		 */
		const T& operator[](unsigned int index) const {
			return m_ptr[index];
		}

		/**
		 * 添字演算子（ミューテータ）です。
		 */
		T& operator[](unsigned int index) {
			return m_ptr[index];
		}

		/**
		 * 生ポインタを取得します。
		 */
		T* get() const {
			return m_ptr;
		}

		/**
		 * カウントポインタを取得します。
		 */
		MessageCounter* getCounter() const {
			return m_count;
		}

	private:
		void refcountdec() {
			--(*m_count);

			if (!(*m_count)) {
				delete [] m_ptr;
				m_ptr = 0;
				delete m_count;
				m_count = 0;
			}
		}
	};

}  // namespace Utility

#endif
